﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private BCPt() As PointApi 
	Private cv As Canvas 	
	Private nPoints As Short 
	Private Smooth As Float = 0.01
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub Draw_BezierCurve(Ca As Canvas, p() As PointApi, pts As Short, noPts As Boolean   )
	Private OldX, OldY, NewX, NewY As Double 
	Dim ptTemp(2) As PointApi 
	Dim u As Float
	Dim Bv As Double 
	cv = Ca
	BCPt=p
	nPoints = pts 
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	If noPts Then
		Dim ft As Font 
		ft = fx.CreateFont("system", 14, False, False)
		cv.DrawText("Number of points = " & nPoints, 10,20,ft,fx.Colors.DarkGray, "LEFT")
		cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,ft,fx.Colors.DarkGray, "LEFT")
	End If	
	For i =0 To nPoints-1
		DrawPoint(BCPt(i))
	Next
	'draws a guide line
	For i= 0 To nPoints - 2
		ptTemp(0) = BCPt(i)
		ptTemp(1) = BCPt(i+1)
		Functions.dashLine (cv, ptTemp, .5, 5, fx.Colors.black)			
	Next
	If nPoints = 1 Then Return
	OldX=BCPt(0).x: OldY=BCPt(0).y 
    For u = 0 To 1 Step Smooth
        NewX = 0: NewY = 0
        For k = 0 To nPoints-1
            Bv = B(k, nPoints-1, u)
            NewX = NewX + BCPt(k).x * Bv
            NewY = NewY + BCPt(k).y * Bv
        Next 
        cv.DrawLine (OldX, OldY ,NewX ,NewY, fx.Colors.red,.5)
		OldX = NewX:OldY = NewY
	Next 
    cv.DrawLine (OldX, OldY ,BCPt(nPoints-1).x ,BCPt(nPoints-1).y, fx.Colors.red,.5)
End Sub
Private Sub B(k As Int, n As Int, u As Float)
	Return  C(n, k) * Power(u, k) *Power( (1 - u), (n - k))
End Sub
Private Sub  C(n As Int , r As Int)
	Return fact(n) / (fact(r) * fact(n - r))
End Sub
Private Sub fact(n As Int)
Dim ft As Int 
If n = 1 OR n = 0 Then
   ft = 1
Else
   ft = n * fact(n - 1)
End If
Return ft
End Sub

Private Sub DrawPoint(pts As PointApi )
	cv.DrawLine(pts.x, pts.y - 5, pts.x, pts.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(pts.x - 5, pts.y, pts.x + 5,pts.y, fx.Colors.Blue,.5)
End Sub