﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private MsgBox As Msgboxes 
	Private DCPt() As PointApi 
	Private cv As Canvas 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub Draw_Circle3Pts(c As Canvas, P() As PointApi)
		cv=c
		DCPt=P
		cv.ClearRect(0,0,cv.Width,cv.Height)	
		Dim f As Font 
		If is_Aligned Then
			f=fx.CreateFont("system", 14,True,False)		
			cv.DrawText("3 points form a straight, impossible to draw a circle.", 10,20,f,fx.Colors.DarkGray , "LEFT")
			Return
		End If		
		Dim DDPt(2) As PointApi 
		Dim cc As Circle3P 
		cc = Circle3Pt 
		P(3).x = cc.Center.x
		P(3).y = cc.Center.y
		For i =0 To 3
			DrawPoint(P(i))
		Next			
		f=fx.CreateFont("system", 14,False,False)
		DDPt(0).x = DCPt(0).x 
		DDPt(0).y = DCPt(0).y
		DDPt(1).x = DCPt(1).x 
		DDPt(1).y = DCPt(1).y
		Functions.dashLine (cv, DDPt, 1, 5, fx.Colors.Green)			'draw chord
		DDPt(0).x = DCPt(1).x 
		DDPt(0).y = DCPt(1).y
		DDPt(1).x = DCPt(2).x 
		DDPt(1).y = DCPt(2).y
		Functions.dashLine(cv, DDPt, 1, 5, fx.Colors.Green)			'draw chord
		DDPt(0).x = cc.Center.x
		DDPt(0).y = cc.Center.y
		DDPt(1).x = cc.CenterChord(0).x 
		DDPt(1).y = cc.CenterChord(0).y
		Functions.dashdotLine(cv, DDPt, 1, 10, fx.Colors.Gray )			'draw center line intersect
		DDPt(1).x = cc.CenterChord(1).x 
		DDPt(1).y = cc.CenterChord(1).y
		Functions.dashdotLine(cv, DDPt, 1, 10, fx.Colors.Gray )			'draw center line intersect 

				'
		DrawPoint(cc.center)	'draw center 
		cv.drawCircle(cc.Center.x, cc.Center.y,cc.radius ,fx.Colors.Red  ,False,1)			'draw circle
		cv.DrawText("X Center = " & cc.Center.x, 10,20,f,fx.Colors.DarkGray , "LEFT")
		cv.DrawText("Y Center = " & cc.Center.y, 10,40,f,fx.Colors.DarkGray, "LEFT")
		cv.DrawText("Radius    = " & cc.radius , 10,60,f,fx.Colors.DarkGray, "LEFT")
		
		cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")
		
End Sub
'**** Circle Through Three Points****
Private Sub Circle3Pt() As Circle3P 
	Dim x1, y1, dx1, dy1, x2, y2, dx2, dy2, dx, dy As Double
	Dim ax, ay, bx, by, cx, cy, radius, ox, oy As Double 
    Dim cpar As Circle3P
	Dim flagErr As Boolean 
	Dim CtErr As Int
	cpar.Initialize 
	CtErr=0
	'**** set point 0****
	flagErr=True
	Do Until flagErr=False
		ax = DCPt(0).x: ay = DCPt(0).y 
		bx = DCPt(1).x: by = DCPt(1).y 
		cx = DCPt(2).x:	cy = DCPt(2).y 
		' **** Get the perpendicular bisector of (x1, y1) and (x2, y2). ****
	    x1 = (bx + ax) / 2
	    y1 = (by + ay) / 2
	    dy1 = bx - ax
	    dx1 = -(by - ay)
	    ' **** Get the perpendicular bisector of (x2, y2) and (x3, y3). ****
	    x2 = (cx + bx) / 2
	    y2 = (cy + by) / 2
	    dy2 = cx - bx
	    dx2 = -(cy - by)
		' **** See where the lines intersect. ****
	    ox = (y1 * dx1 * dx2 + x2 * dx1 * dy2 - x1 * dy1 * dx2 - y2 * dx1 * dx2) / (dx1 * dy2 - dy1 * dx2)
	    oy = (ox - x1) * dy1 / dx1 + y1
	    dx = ox - ax
	    dy = oy - ay

		radius = Sqrt(dx * dx + dy * dy)
		flagErr=False
		'prevents NaN error (probably square root of a negative number) (Not a Number)
		If Functions.IsNan(radius) Then flagErr=True
		If Functions.IsNan(ox) Then flagErr=True
		If Functions.IsNan(oy) Then flagErr=True
		If flagErr Then 
			CtErr=CtErr+1
			If CtErr=2 Then
				Log("Error (NaN error)")
				ExitApplication
			End If
			'**** swap point 1, point 2 and redraw ****
			Dim ptTemp As PointApi 
			ptTemp = DCPt(1)
			DCPt(1) = DCPt(2)
			DCPt(2) = ptTemp
		Else
			cpar.radius = radius
			cpar.Center.x = ox
			cpar.Center.y = oy
			cpar.CenterChord(0).x = x1
			cpar.CenterChord(0).y = y1
			cpar.CenterChord(1).x = x2
			cpar.CenterChord(1).y = y2
		End If
	Loop
	Return cpar
End Sub	
Private Sub is_Aligned() As Boolean 
	Dim angle1, angle2 As Float
	Dim dDist(4) As Double 
	Dim sDist(4) As String
	Dim ptTemp As PointApi
	sDist(0) ="0, 1"
	sDist(1) ="1, 2"
	sDist(2) ="2, 0"
	dDist(0) =  Functions.Distance(DCPt(0),DCPt(1)) 'Sqrt(Power(pt(0).x,2) + Power(pt(0).y,2))   	'dist to point 0 
	dDist(1) =  Functions.Distance(DCPt(1),DCPt(2))	'Sqrt(Power(pt(1).x,2) + Power(pt(1).y,2))   	'dist to point 1 
	dDist(2) =  Functions.Distance(DCPt(2),DCPt(0))	'Sqrt(Power(pt(2).x,2) + Power(pt(2).y,2))   	'dist to point 2
	'***** Arrange points ******	
	For i=0 To 1
		For x= i+1 To 2
			If dDist(i)>dDist(x) Then	
				dDist(3)=dDist(i)
				dDist(i)=dDist(x)
				dDist(x)=dDist(3)
				sDist(3)=sDist(i)
				sDist(i)=sDist(x)
				sDist(x)=sDist(3)						
			End If
		Next
	Next
	If sDist(0).Contains("0") AND sDist(1).Contains("0") Then
		ptTemp = DCPt(0)
		DCPt(0) = DCPt(1)
		DCPt(1) = ptTemp
	Else If sDist(0).Contains("2") AND sDist(1).Contains("2") Then
		ptTemp = DCPt(1)
		DCPt(1) = DCPt(2)
		DCPt(2) = ptTemp
	End If
	'**** Possible alignments checks ****
	angle1 = Functions.AngleCalc(DCPt(1).x, DCPt(1).y, DCPt(0).x, DCPt(0).y)
	angle2 = Functions.AngleCalc(DCPt(2).x, DCPt(2).y, DCPt(0).x, DCPt(0).y)
	If angle1=angle2 Then Return True
	Return False
End Sub

Private Sub DrawPoint(p As PointApi )
	cv.DrawLine(p.x, p.y - 5, p.x, p.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(p.x - 5, p.y, p.x + 5,p.y, fx.Colors.Blue,.5)
End Sub