﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private CSPt() As PointApi 
	Private cv As Canvas 	
	Private nPoints As Short 
	Private p() As Double    '
	Private u() As Double	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub Draw_CubicSpline(c As Canvas, p1() As PointApi, pts As Short, noPts As Boolean   )
	Private OldX, OldY As Double 
	Dim ptTemp As PointApi 
	cv = c
	CSPt=p1
	nPoints = pts 
	'XAxis puts in ascending order
	For x = 0 To nPoints - 2
		For y = x+1 To nPoints-1
			If CSPt(x).x > CSPt(y).x Then
				ptTemp = CSPt(x)
				CSPt(x) = CSPt(y)
				CSPt(y) = ptTemp			
			End If
		Next
	Next
	'Checks if there are two equal xAxis
	For x = 0 To nPoints - 2
		If CSPt(x).x = CSPt(x+1).x Then
			CSPt(x+1).x = CSPt(x+1).x + .1		'adds 0.1 to prevent errors
		End If
	Next
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	If noPts Then
		Dim ft As Font 
		ft = fx.CreateFont("system", 14, False, False)
		cv.DrawText("Number of points = " & nPoints, 10,20,ft,fx.Colors.DarkGray, "LEFT")
		cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,ft,fx.Colors.DarkGray, "LEFT")
	End If
	Private p(nPoints) As Double    '
	Private u(nPoints) As Double	
	For i =0 To nPoints-1
		DrawPoint(CSPt(i))
	Next	
	Dim F As Font 
    Dim piece As Short, xPos As Double, yPos As Double
    Dim stp1 As Double
    SetPandU
	OldX=CSPt(0).x: OldY=CSPt(0).y 
    For piece = 0 To nPoints  - 2
        If CSPt(piece).x < CSPt(piece + 1).x Then stp1 = 1 Else stp1 = -1
        For xPos =CSPt(piece).x  To CSPt(piece + 1).x  Step stp1
            yPos = getCurvePoint(piece, xPos)
           cv.DrawLine (OldX, OldY ,xPos ,yPos, fx.Colors.red,.3)
		   OldX=xPos
		   OldY=yPos
        Next
    Next

End Sub
Private Sub getCurvePoint(i As Short, v As Double) As Double
    Dim t As Double
	Dim GCP As Double 
    'derived curve equation (which uses p's and u's for coefficients)
    t = (v - CSPt(i).x) / u(i)
	
    GCP = t * CSPt(i + 1).y + (1 - t) * CSPt(i).y + u(i) * u(i) * (F(t) * p(i + 1) + F(1 - t) * p(i)) / 6.0
	Return GCP
End Sub
Private Sub F(x As Double) As Double
        Return  (x * x * x - x)
End Sub
Private Sub SetPandU()
    Dim i As Short
    Dim d(nPoints) As Double
    Dim w(nPoints) As Double
	'Routine to compute the parameters of our cubic spline.  Based on equations derived from some basic facts...
	'Each segment must be a cubic polynomial.  Curve segments must have equal first and second derivatives
	'at knots they share.  General algorithm taken from a book which has long since been lost.

	'The math that derived this stuff is pretty messy...  expressions are isolated and put into
	'arrays.  we're essentially trying to find the values of the second derivative of each polynomial
	'at each knot within the curve.  That's why theres only N-2 p's (where N is # points).
	'later, we use the p's and u's to calculate curve points...

    For i = 1 To nPoints - 2
        d(i) = 2 * (CSPt(i + 1).x - CSPt(i - 1).x)
    Next
    For i = 0 To nPoints - 2
        u(i) = CSPt(i + 1).x - CSPt(i).x
    Next
    For i = 1 To nPoints - 2
        w(i) = 6.0 * ((CSPt(i + 1).y - CSPt(i).y) / u(i) - (CSPt(i).y - CSPt(i - 1).y) / u(i - 1))
    Next
    For i = 1 To nPoints - 3
        w(i + 1) = w(i + 1) - w(i) * u(i) / d(i)
        d(i + 1) = d(i + 1) - u(i) * u(i) / d(i)
    Next
    p(0) = 0.0
    For i = nPoints - 2 To 1 Step -1
        p(i) = (w(i) - u(i) * p(i + 1)) / d(i)
    Next
    p(nPoints-1) = 0.0
End Sub
Private Sub DrawPoint(pts As PointApi )
	cv.DrawLine(pts.x, pts.y - 5, pts.x, pts.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(pts.x - 5, pts.y, pts.x + 5,pts.y, fx.Colors.Blue,.5)
End Sub