﻿Type=StaticCode
Version=2.2
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub
Public Sub draw_Circle(c As Canvas, p()As PointApi )
	Dim dist As Double = Distance(p(0), p(1))
	c.drawCircle(p(0).x, p(0).y, dist, fx.Colors.Red, False, 1)
End Sub
Public Sub Distance(p0 As PointApi, p1 As PointApi) As Double
	Dim d As Double
	d = Sqrt(Power(Abs(p1.x - p0.x),2) + Power(Abs(p1.y - p0.y),2))
	Return d
End Sub
Public Sub IsNan(D As Double) As Boolean
   Return D <> D
End Sub
Public Sub AngleCalc(aX1 As Double, aY1 As Double, CX As Double, CY As Double) As Double
	Private opp, adj, Rad As Double
	Private toRadian As Double = (cPI / 180)
	Private toDegree As Double = (180 / cPI)
	opp = (aX1 - CX)
	adj = (aY1 - CY)
	If adj = 0 Then
	    If CX < aX1 Then
	        Rad = 270 * toRadian
	    Else If CX > aX1 Then
	        Rad = 90 * toRadian
	    End If
	Else
	    Rad = ATan(opp / adj)
	End If
	'this is a simple way of solving the prob of Atan() only functioning
	'correctly if x was negative; it just adds 180 degrees
	If CY < aY1 Then Rad = Rad + (180 * toRadian)
	'this 'fixes' a problem of the radians being negative after 270 degrees
	'i've never figured out why this problem even occurs
	If Rad < 0 Then Rad = Rad + (360 * toRadian)
	'converts the radian value to degrees
	Return (Rad * toDegree)
End Sub
Public Sub dotLine(cv As Canvas, DPt() As PointApi, stkWdt As Double, dotSpc As Double, clr As Paint )
	Dim NewPt As PointApi 
	Dim stp As Int 
	Dim Angle, SinA, CosA,lng As Double
	Dim ct As Double 
	Angle=AngleCalc(DPt(0).x,DPt(0).y, DPt(1).x, DPt(1).y)
	SinA = Sin(Angle * cPI / 180)
	CosA = Cos(Angle * cPI / 180)
	lng=Sqrt(Power(Abs(DPt(0).x - DPt(1).x),2) + Power(Abs(DPt(0).y - DPt(1).y),2))
	If IsNan(lng) Then
		Log("Error (NaN error)")
	End If
	stp=lng/dotSpc
	dotSpc=lng/stp
	lng=lng+dotSpc/4
	For ct = 0 To lng Step dotSpc
		NewPt.x   = DPt(0).x + SinA * ct
    	NewPt.y =DPt(0).y + CosA * ct
		cv.drawCircle(NewPt.x, NewPt.y,stkWdt/2,clr, True,.5)
	Next
End Sub
Public Sub dashLine(cv As Canvas, DLpt() As PointApi, stkWdt As Double, dotSpc As Double, clr As Paint )
	Dim NewPt(2) As PointApi 
	Dim stp As Int 
	Dim BlankSpc As Float = 1.75	'Percent
	Dim Angle, SinA, CosA,lng As Double
	Dim ct As Double 
	Angle= AngleCalc(DLpt(0).x,DLpt(0).y, DLpt(1).x, DLpt(1).y)
	SinA = Sin(Angle * cPI / 180)
	CosA = Cos(Angle * cPI / 180)
	lng=Sqrt(Power(Abs(DLpt(0).x - DLpt(1).x),2) + Power(Abs(DLpt(0).y - DLpt(1).y),2))
	If lng < dotSpc * 2.75 Then
		cv.drawline(DLpt(0).x, DLpt(0).y,DLpt(1).x, DLpt(1).y,clr,stkWdt)
		Return
	End If
	lng = lng - dotSpc
	dotSpc = dotSpc*BlankSpc
	stp = lng / dotSpc
	dotSpc = lng / stp
	lng = lng + dotSpc / 2
	For ct = 0 To lng Step dotSpc
		NewPt(0).x   = DLpt(0).x + SinA * ct
    	NewPt(0).y = DLpt(0).y + CosA * ct
		NewPt(1).x = DLpt(0).x + SinA * (ct+dotSpc/BlankSpc)
		NewPt(1).y =  DLpt(0).y + CosA * (ct+dotSpc/BlankSpc)
		cv.drawline(NewPt(0).x, NewPt(0).y,NewPt(1).x, NewPt(1).y,clr,stkWdt)
	Next
End Sub
Public Sub dashdotLine(c As Canvas, ddlPt() As PointApi, stkWdt As Double, dotSpc As Double, clr As Paint )
	Dim NewPt(3) As PointApi 
	Dim stp As Int 
	Dim BlankSpc As Float = .50	'Percent
	Dim Angle, SinA, CosA,lng As Double
	Dim ct As Double 
	Angle= AngleCalc(ddlPt(0).x,ddlPt(0).y, ddlPt(1).x, ddlPt(1).y)
	SinA = Sin(Angle * cPI / 180)
	CosA = Cos(Angle * cPI / 180)
	lng=Sqrt(Power(Abs(ddlPt(0).x - ddlPt(1).x),2) + Power(Abs(ddlPt(0).y - ddlPt(1).y),2))
	lng=lng-dotSpc 
	BlankSpc = BlankSpc * dotSpc * 2 + 1
	dotSpc=dotSpc+BlankSpc
	stp=lng/dotSpc
	dotSpc=lng/stp
	lng=lng-dotSpc/2
	For ct = 0 To lng Step dotSpc
		NewPt(0).x   = ddlPt(0).x + SinA * ct
    	NewPt(0).y = ddlPt(0).y + CosA * ct
		NewPt(1).x = ddlPt(0).x + SinA * (ct+dotSpc-BlankSpc)
		NewPt(1).y =  ddlPt(0).y + CosA * (ct+dotSpc-BlankSpc)
		NewPt(2).x = ddlPt(0).x + SinA * (ct+dotSpc-BlankSpc/2)
		NewPt(2).y =  ddlPt(0).y + CosA * (ct+dotSpc-BlankSpc/2)		
		c.drawline(NewPt(0).x, NewPt(0).y,NewPt(1).x, NewPt(1).y,clr,stkWdt)
		c.drawCircle(NewPt(2).x, NewPt(2).y,stkWdt/2,clr, True,1)
	Next
	NewPt(0).x   = ddlPt(0).x + SinA * ct
	NewPt(0).y = ddlPt(0).y + CosA * ct
	c.drawline(NewPt(0).x, NewPt(0).y,ddlPt(1).x, ddlPt(1).y,clr,stkWdt)
End Sub
