﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private LCPt() As PointApi 
	Private cv As Canvas 
	Private Colision(2) As Boolean 	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub Draw_LineCircleIntersection(c As Canvas, p() As PointApi )
	'Using 	p(0) = center of the circle 
	'		p(1) = radius of the circle
	'		p(2) AND p(3) = line intercede
	cv = c
	LCPt = p
	Dim ctColision As Short 
	Dim cl As Circle3P 
	Dim ln As Short 
	Dim f As Font 
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	f=fx.CreateFont("system", 14,False,False)			
	For i = 0 To 3
		DrawPoint(LCPt(i))
	Next	
	cl=FindLineCircleIntersections
	cv.drawCircle(LCPt(0).x, LCPt(0).y,cl.radius ,fx.Colors.Red  ,False,1)			'draw circle
	cv.DrawLine(LCPt(2).x, LCPt(2).y, LCPt(3).x, LCPt(3).y , fx.Colors.green,.5)	
	ctColision=0
	ln=0
	If cl.CenterChord(0).x<>-1 Then
		ln = ln + 20
		cv.DrawText("X Intersection 1 = " & cl.CenterChord(0).x, 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20
		cv.DrawText("Y Intersection 1 = " & cl.CenterChord(0).y, 10, ln, f, fx.Colors.DarkGray, "LEFT")		
		If Colision(0) Then
			ctColision=ctColision + 1
			drawPointCircle(cl.CenterChord(0), fx.Colors.Magenta)
		Else
			drawPointCircle(cl.CenterChord(0), fx.Colors.Blue )
		End If
	End If
	
	If cl.CenterChord(1).x<>-1 Then
		ln = ln + 20
		cv.DrawText("X Intersection 2 = " & cl.CenterChord(1).x, 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20
		cv.DrawText("Y Intersection 2 = " & cl.CenterChord(1).y, 10, ln, f, fx.Colors.DarkGray, "LEFT")		
		If Colision(1) Then
			ctColision=ctColision + 1
			drawPointCircle(cl.CenterChord(1), fx.Colors.Magenta)
		Else
			drawPointCircle(cl.CenterChord(1), fx.Colors.Blue )
		End If
	End If
	Dim st As String
	If cl.CenterChord(0).x = -1 Then
		st = "INTERSECTION NOT DETECTED"
	Else If cl.CenterChord(1).x = -1 Then
		st = "ONE INTERSECTIONS DETECTED"
	Else
		st = "TWO INTERSECTIONS DETECTED"
	End If
	ln = ln + 20
	cv.DrawText(st, 10,ln,f,fx.Colors.DarkGray, "LEFT")	
	If Colision(0) AND Colision(1) Then
		st = "TWO COLISIONS DETECTED"
	Else If Colision(0) OR Colision(1) Then
		st = "ONE COLISION DETECTED"
	Else
		st = "NO COLISION DETECTED"
	End If
	ln = ln + 20
	cv.DrawText(st, 10,ln,f,fx.Colors.DarkGray, "LEFT")		
	cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")
	
End Sub
Private Sub FindLineCircleIntersections() As Circle3P 
        Dim dx As Float
        Dim dy As Float
        Dim A As Float
        Dim B As Float
        Dim c As Float
        Dim det As Float 
        Dim t As Float
		Dim cc As Circle3P 
		cc.Initialize
		cc.radius =Functions.Distance(LCPt(0),LCPt(1))
		cc.Center.x = LCPt(0).x
		cc.Center.y = LCPt(0).y 
		cc.CenterChord(0).x = -1.0
		cc.CenterChord(0).y = -1.0		
		cc.CenterChord(1).x = -1.0
		cc.CenterChord(1).y = -1.0      
		Colision(0) = False
		Colision(1) = False
		dx = LCPt(3).x - LCPt(2).x  
        dy = LCPt(3).y - LCPt(2).y 

        A = dx * dx + dy * dy
        B = 2 * (dx * (LCPt(2).x - cc.Center.x) + dy * (LCPt(2).y - cc.Center.y))
        c = (LCPt(2).x - cc.Center.x) * (LCPt(2).x - cc.Center.x) + (LCPt(2).y - cc.Center.y) * (LCPt(2).y - cc.Center.y) - cc.radius * cc.radius
	

        det = B * B - 4 * A * c
        If (A <= 0.0000001) OR (det < 0) Then
            ' No real solutions.
            Return cc
        Else If det = 0 Then
			
            ' One solution.
            t = -B / (2 * A)
 			Colision(0) = t>=0 AND t<=1
           	cc.CenterChord(0).x = LCPt(2).x + t * dx
            cc.CenterChord(0).y = LCPt(2).y + t * dy
            Return cc
        Else

            ' Two solutions.
            t = (-B + Sqrt(det)) / (2 * A)
			Colision(0) = t>=0 AND t<=1
            cc.CenterChord(0).x = LCPt(2).x + t * dx
            cc.CenterChord(0).y = LCPt(2).y + t * dy			
            
t = (-B - Sqrt(det)) / (2 * A)
			Colision(1) = t>=0 AND t<=1
            cc.CenterChord(1).x = LCPt(2).x + t * dx
            cc.CenterChord(1).y = LCPt(2).y + t * dy
			Return cc
        End If
   End Sub
Private Sub drawPointCircle(p As PointApi, Clr As Paint)
	cv.DrawLine(p.x, p.y - 10, p.x, p.y + 10, Clr,.5)
	cv.DrawLine(p.x - 10, p.y, p.x + 10, p.y, Clr,.5)	
	cv.drawCircle(p.x , p.y, 10, Clr, False,.5)	
End Sub
Private Sub DrawPoint(p As PointApi )
	cv.DrawLine(p.x, p.y - 5, p.x, p.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(p.x - 5, p.y, p.x + 5,p.y, fx.Colors.Blue,.5)
End Sub