﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private MsgBox As Msgboxes 
	Private LIPt() As PointApi 
	Private cv As Canvas 
	Private Colision As Boolean 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub
Public Sub Draw_LinesIntersection(c As Canvas, P() As PointApi)
	'***** Using p(0) p(1) to line 1   -   p(1) p(2) to the line 2
	Dim ptInt As PointApi 
	cv=c
	LIPt=P
	cv.ClearRect(0,0,cv.Width,cv.Height)
	For i =0 To 3
		DrawPoint(LIPt(i))
	Next	
	Dim f As Font 
	cv.DrawLine(LIPt(0).x, LIPt(0).y , LIPt(1).x, LIPt(1).y, fx.Colors.Red, 1)
	cv.DrawLine(LIPt(2).x, LIPt(2).y , LIPt(3).x, LIPt(3).y, fx.Colors.Green,1)
	If detect_parallelism Then
		f=fx.CreateFont("system", 14, True,False)		
		cv.DrawText("Parallel lines ... not intercede." , 10,30,f,fx.Colors.red, "LEFT")
		cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")
		Return
	End If
	f=fx.CreateFont("system", 14,False,False)		
	ptInt=get_line_intersection
	cv.DrawText("X Intersection = " & ptInt.x, 10, 20, f, fx.Colors.DarkGray , "LEFT")
	cv.DrawText("Y Intersection = " & ptInt.y, 10, 40, f, fx.Colors.DarkGray, "LEFT")
	If Colision Then
		cv.DrawText("COLISION DETECTED" , 10,60,f,fx.Colors.DarkGray, "LEFT")		
		drawPointCircle(ptInt, fx.Colors.Magenta)
	Else
		cv.DrawText("NO COLISION DETECTED" , 10,60,f,fx.Colors.DarkGray, "LEFT")					
		drawPointCircle(ptInt, fx.Colors.Blue )
	End If
	cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")

End Sub
Private Sub detect_parallelism() As Boolean 
	Dim slope(2),S1,S2 As Float 
	S1 = LIPt(1).x - LIPt(0).x
	S2 = LIPt(1).y - LIPt(0).y
	slope(0)=S2/S1
	S1 = LIPt(3).x - LIPt(2).x
	S2 = LIPt(3).y - LIPt(2).y
	slope(1)=S2/S1
	If slope(0)=slope(1) Then
		Return True
	End If
	Return False
End Sub

Private Sub get_line_intersection() As PointApi 
  	Private s1, s2, i As PointApi
    s1.x = LIPt(1).x - LIPt(0).x: s1.y = LIPt(1).y - LIPt(0).y
    s2.x = LIPt(3).x - LIPt(2).x: s2.y = LIPt(3).y - LIPt(2).y

    Private s, t As Double 
    s = (-s1.y * (LIPt(0).x - LIPt(2).x) + s1.x * (LIPt(0).y - LIPt(2).y)) / (-s2.x * s1.y + s1.x * s2.y)
    t = ( s2.x * (LIPt(0).y - LIPt(2).y) - s2.y * (LIPt(0).x - LIPt(2).x)) / (-s2.x * s1.y + s1.x * s2.y)

    If (s >= 0 AND s <= 1 AND t >= 0 AND t <= 1) Then
		Colision = True
	Else
		Colision = False
	End If
    i.x = LIPt(0).x + (t * s1.x)
   	i.y = LIPt(0).y + (t * s1.y)
    Return i
End Sub
Private Sub drawPointCircle(p As PointApi, Clr As Paint)
	cv.DrawLine(p.x, p.y - 10, p.x, p.y + 10, Clr,.5)
	cv.DrawLine(p.x - 10, p.y, p.x + 10, p.y, Clr,.5)	
	cv.drawCircle(p.x , p.y, 10, Clr, False,.5)	
End Sub
Private Sub DrawPoint(p As PointApi )
	cv.DrawLine(p.x, p.y - 5, p.x, p.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(p.x - 5, p.y, p.x + 5,p.y, fx.Colors.Blue,.5)
End Sub